package quimufu.colourful_portals.config;

import com.google.common.base.CaseFormat;
import com.google.common.collect.ImmutableMap;
import de.siphalor.tweed4.annotated.AConfigEntry;
import de.siphalor.tweed4.annotated.ATweedConfig;
import de.siphalor.tweed4.config.ConfigEnvironment;
import de.siphalor.tweed4.config.ConfigScope;
import de.siphalor.tweed4.tailor.cloth.ClothData;
import net.minecraft.util.DyeColor;
import quimufu.colourful_portals.ColourfulPortalsMod;

import java.util.Map;

@ATweedConfig(serializer = "tweed4:hjson", scope = ConfigScope.GAME, environment = ConfigEnvironment.SERVER, tailors = {"tweed4:lang_json_descriptions", "tweed4:coat", "tweed4:json_schema"}, casing = CaseFormat.LOWER_HYPHEN)
@ClothData(modid = ColourfulPortalsMod.MOD_ID)
public class ColourfulPortalConfig {

    @AConfigEntry(comment =
            """
                    Allows you to add additional blocks as portalBlocks,
                        assigning them the color of the portal plane.
                    null causes the portals out of that block to have *no* plane.
                    Changes in the plane color will only apply to new portals,
                        or on portal update.
                    """)
    public static Map<String, DyeColor> portalBlocks = ImmutableMap.ofEntries(
            Map.entry("minecraft:white_wool", DyeColor.WHITE),
            Map.entry("minecraft:orange_wool", DyeColor.ORANGE),
            Map.entry("minecraft:magenta_wool", DyeColor.MAGENTA),
            Map.entry("minecraft:light_blue_wool", DyeColor.LIGHT_BLUE),
            Map.entry("minecraft:yellow_wool", DyeColor.YELLOW),
            Map.entry("minecraft:lime_wool", DyeColor.LIME),
            Map.entry("minecraft:pink_wool", DyeColor.PINK),
            Map.entry("minecraft:gray_wool", DyeColor.GRAY),
            Map.entry("minecraft:light_gray_wool", DyeColor.LIGHT_GRAY),
            Map.entry("minecraft:cyan_wool", DyeColor.CYAN),
            Map.entry("minecraft:purple_wool", DyeColor.PURPLE),
            Map.entry("minecraft:blue_wool", DyeColor.BLUE),
            Map.entry("minecraft:brown_wool", DyeColor.BROWN),
            Map.entry("minecraft:green_wool", DyeColor.GREEN),
            Map.entry("minecraft:red_wool", DyeColor.RED),
            Map.entry("minecraft:black_wool", DyeColor.BLACK));
}
